// All properties that a Configuration has
export interface ConfigurationProps {
  identifier: ConfigurationIdentifier;
  value: ConfigurationValue;
  type: ConfigurationType;
}

// Properties that are needed for a Configuration creation
export interface CreateConfigurationProps {
  identifier: ConfigurationIdentifier;
  value: ConfigurationValue;
  type: ConfigurationType;
}

export interface UpdateConfigurationProps {
  value: ConfigurationValue;
}

export enum ConfigurationDomain {
  CARPOOL = 'CARPOOL',
  USER = 'USER',
}

export enum ConfigurationType {
  BOOLEAN = 'BOOLEAN',
  NUMBER = 'NUMBER',
  STRING = 'STRING',
}

export type ConfigurationIdentifier = {
  domain: ConfigurationDomain;
  key: ConfigurationKey;
};

export type ConfigurationKey = string;
export type ConfigurationValue = string;

export type ConfigurationItems = Record<
  ConfigurationDomain,
  Record<
    ConfigurationKey,
    {
      value: ConfigurationValue;
      type: ConfigurationType;
      enum?: Array<string>;
    }
  >
>;
