import { DomainEvent, DomainEventProps } from '@mobicoop/ddd-library';
import {
  ConfigurationIdentifier,
  ConfigurationType,
  ConfigurationValue,
} from '../configuration.types';

export class ConfigurationSetDomainEvent extends DomainEvent {
  readonly identifier: ConfigurationIdentifier;
  readonly value: ConfigurationValue;
  readonly type: ConfigurationType;

  constructor(props: DomainEventProps<ConfigurationSetDomainEvent>) {
    super(props);
    this.identifier = props.identifier;
    this.type = props.type;
    this.value = props.value;
  }
}
